Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2005132 - Review Request: python-hdf5storage - Read/write Python types to/from HDF5 files, including MATLAB v7.3 MAT files
Summary: Review Request: python-hdf5storage - Read/write Python types to/from HDF5 fil...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ben Beasley
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora 1931183
TreeView+ depends on / blocked
 
Reported: 2021-09-16 20:38 UTC by Ankur Sinha (FranciscoD)
Modified: 2021-11-27 01:09 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-11-27 01:09:32 UTC
Type: ---
Embargoed:
code: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2021-09-16 20:38:28 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-hdf5storage/python-hdf5storage.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-hdf5storage/python-hdf5storage-0.1.18-1.fc35.src.rpm

Description:
This Python package provides high level utilities to read/write a variety of
Python types to/from HDF5 (Heirarchal Data Format) formatted files. This
package also provides support for MATLAB MAT v7.3 formatted files, which are
just HDF5 files with a different extension and some extra meta-data.

All of this is done without pickling data. Pickling is bad for security because
it allows arbitrary code to be executed in the interpreter. One wants to be
able to read possibly HDF5 and MAT files from untrusted sources, so pickling is
avoided in this package.

The package's documetation is found at http://pythonhosted.org/hdf5storage/

The package's source code is found at
https://github.com/frejanordsiek/hdf5storage

Fedora Account System Username: ankursinha

Comment 1 Ben Beasley 2021-11-08 20:46:36 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Dist tag is present.
  (OK; fedora-review does not understand rpmautospec)

- Some issues with Sphinx-generated HTML documentation regarding bundled and
  minified web assets have been identified that make it unsuitable for
  packaging (even though there is a long history of doing so in Fedora). See
  https://bugzilla.redhat.com/show_bug.cgi?id=2006555 and
  https://lists.fedoraproject.org/archives/list/packaging@lists.fedoraproject.org/thread/LLUAURXZVADATHK65HBPPBHKF4EM4UC3/
  for details and discussion.

  Given this, you have two reasonable options:

    - Don’t package the Sphinx-generated documentation at all
    - Build a PDF, which is probably acceptable, rather than HTML.

  If you want to go with PDF documentation, let me know and I’ll be happy to
  make and upload a version of the spec that builds it. You can look at
  https://src.fedoraproject.org/rpms/python-engineio/blob/rawhide/f/python-engineio.spec
  for an example.

- While you are not running the tests (waiting for an upstream release with
  pytest instead of nose), you must run a “smoke test” that simply imports the
  public API modules
  (https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_running_tests).

  The easiest way to do this is to change

    %pyproject_buildrequires %{?with_tests:-r}

  to

    %pyproject_buildrequires -r

  and

    %if %{with tests}
    %{pytest}
    # or %%{tox}
    %endif

  to

    %if %{with tests}
    %{pytest}
    # or %%{tox}
    %else
    %pyproject_check_import
    %endif

  (but note that you will have to wait for the latest versions of
  pyproject-rpm-macros and python-rpm-macros to reach stable releases before
  building for F35 and older), or if you don’t want to wait:

  to

    %if %{with tests}
    %{pytest}
    # or %%{tox}
    %else
    %py3_check_import hdf5storage
    %endif

  (given that in this case the top-level __init__.py imports everything else).

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 2-Clause License". 25 files have
     unknown license. Detailed output of licensecheck in
     /home/reviewer/2005132-python-hdf5storage/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package contains no bundled libraries without FPC exception.

     Ok except for Sphinx HTML documentation

[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines

     (except as noted)

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-hdf5storage
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/frejanordsiek/hdf5storage/archive/0.1.18/hdf5storage-0.1.18.tar.gz :
  CHECKSUM(SHA256) this package     : ce24b6267d1f59964b116cfa604c3142a1c9d7ac3a4704bca84963d820265e58
  CHECKSUM(SHA256) upstream package : ce24b6267d1f59964b116cfa604c3142a1c9d7ac3a4704bca84963d820265e58


Requires
--------
python3-hdf5storage (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(h5py)
    python3.10dist(numpy)

python-hdf5storage-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-hdf5storage:
    python-hdf5storage
    python3-hdf5storage
    python3.10-hdf5storage
    python3.10dist(hdf5storage)
    python3dist(hdf5storage)

python-hdf5storage-doc:
    python-hdf5storage-doc



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2005132
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: R, fonts, Haskell, C/C++, SugarActivity, Perl, Ocaml, PHP, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH
============================ rpmlint session starts ============================
rpmlint: 2.1.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 4

python-hdf5storage.spec:96: W: macro-in-%changelog %autochangelog
python-hdf5storage.spec:96: W: macro-in-%changelog %autochangelog
 3 packages and 1 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 1.0 s

Comment 2 Ankur Sinha (FranciscoD) 2021-11-16 17:50:26 UTC
Hi Ben,

thanks for the review.

I've dropped the doc sub-package for the moment, and enabled the import test.

Updated spec/srpm:

https://ankursinha.fedorapeople.org/python-hdf5storage/python-hdf5storage.spec
https://ankursinha.fedorapeople.org/python-hdf5storage/python-hdf5storage-0.1.18-2.fc36.src.rpm

Cheers,
Ankur

diff --git a/python-hdf5storage.spec b/python-hdf5storage.spec
index 25a4ab2..9fce3ed 100644
--- a/python-hdf5storage.spec
+++ b/python-hdf5storage.spec
@@ -47,16 +47,6 @@ BuildRequires:  %{py3_dist nose}
 
 %description -n python3-hdf5storage %_description
 
-%package doc
-Summary:        Documentation for %{name}
-BuildRequires:  make
-BuildRequires:  %{py3_dist sphinx}
-BuildRequires:  %{py3_dist numpydoc}
-BuildRequires:  %{py3_dist sphinx-rtd-theme}
-
-%description doc
-This package provides documentation for %{name}.
-
 %prep
 %forgesetup
 
@@ -65,16 +55,12 @@ This package provides documentation for %{name}.
 # find . -type f -name "*.py" -exec sed -i '/^#![  ]*\/usr\/bin\/env.*$/ d' {} 2>/dev/null ';'
 
 %generate_buildrequires
-%pyproject_buildrequires %{?with_tests:-r}
+%pyproject_buildrequires -r
 
 
 %build
 %pyproject_wheel
 
-# Sometimes needed so sphinx can import the module
-PYTHONPATH=".:.." make -C doc SPHINXBUILD=sphinx-build-3 html
-rm -rf doc/build/html/{.doctrees,.buildinfo} -vf
-
 %install
 %pyproject_install
 %pyproject_save_files hdf5storage
@@ -82,15 +68,11 @@ rm -rf doc/build/html/{.doctrees,.buildinfo} -vf
 %check
 %if %{with tests}
 %{pytest}
-# or %%{tox}
 %endif
+%pyproject_check_import hdf5storage
 
 %files -n python3-hdf5storage -f %{pyproject_files}
 %doc README.rst
 
-%files doc
-%license COPYING.txt
-%doc doc/build/html
-
 %changelog
 %autochangelog

Comment 3 Ben Beasley 2021-11-16 17:55:15 UTC
Thanks! I’m running a little behind on pending package reviews, but I’ll revisit this as soon as I can. It looks like it will not take long to finish the review.

Comment 4 Ben Beasley 2021-11-17 15:30:55 UTC
The package is APPROVED; however, please see the recommendations below.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Dist tag is present.

  OK (rpmautospec)

- This:

    %pyproject_check_import hdf5storage

  should be

    %pyproject_check_import

  as the point of the %pyproject_… version of this macro is to figure out which
  modules to test-import based on what was recorded by %pyproject_save_files.

  It seems to work with the extra parameter—it just test-imports the top-level
  package twice—so I won’t block approval, but please do remove the extra
  argument before import.

- This is no longer needed and can be removed, since python3-devel now depends
  on pyproject-rpm-macros on all current Fedora releases.

    BuildRequires:  pyproject-rpm-macros

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 2-Clause License". 25 files have
     unknown license. Detailed output of licensecheck in
     /home/reviewer/2005132-python-hdf5storage/20211117/2005132-python-
     hdf5storage/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.

     $ rpm -qL -p results/python3-hdf5storage-0.1.18-2.fc36.noarch.rpm 
     /usr/lib/python3.10/site-packages/hdf5storage-0.1.18.dist-info/COPYING.txt

[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.

     Rebuild --with tests succeeds.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.

     Re-enable tests when a future release switches from nose to pytest.

     Correctly using import “smoke tests” until then.

     Nose-based tests pass when manually enabled.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)

     OK (rpmautospec)

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/frejanordsiek/hdf5storage/archive/0.1.18/hdf5storage-0.1.18.tar.gz :
  CHECKSUM(SHA256) this package     : ce24b6267d1f59964b116cfa604c3142a1c9d7ac3a4704bca84963d820265e58
  CHECKSUM(SHA256) upstream package : ce24b6267d1f59964b116cfa604c3142a1c9d7ac3a4704bca84963d820265e58


Requires
--------
python3-hdf5storage (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(h5py)
    python3.10dist(numpy)



Provides
--------
python3-hdf5storage:
    python-hdf5storage
    python3-hdf5storage
    python3.10-hdf5storage
    python3.10dist(hdf5storage)
    python3dist(hdf5storage)



Diff spec file in url and in SRPM
---------------------------------
--- /home/reviewer/2005132-python-hdf5storage/20211117/2005132-python-hdf5storage/srpm/python-hdf5storage.spec	2021-11-17 09:50:40.430084032 -0500
+++ /home/reviewer/2005132-python-hdf5storage/20211117/2005132-python-hdf5storage/srpm-unpacked/python-hdf5storage.spec	2021-11-16 12:43:46.000000000 -0500
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 2;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 # upstream has moved to pytest but not made a release yet.
 # For the time being, it uses nose, so we disable tests by default
@@ -76,3 +85,7 @@
 
 %changelog
-%autochangelog
+* Tue Nov 16 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 0.1.18-2
+- Uncommitted changes
+
+* Thu Sep 16 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 0.1.18-1
+- feat: ready for review


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2005132
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: C/C++, Java, fonts, SugarActivity, Perl, PHP, Ocaml, R, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Ankur Sinha (FranciscoD) 2021-11-18 11:45:36 UTC
Thanks Ben, requesting SCM now, and I'll make the remaining tweaks before import.

Comment 6 Gwyn Ciesla 2021-11-18 16:48:48 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-hdf5storage

Comment 7 Fedora Update System 2021-11-19 19:09:40 UTC
FEDORA-2021-51f5b38aaa has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-51f5b38aaa \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-51f5b38aaa

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 8 Fedora Update System 2021-11-27 01:09:32 UTC
FEDORA-2021-51f5b38aaa has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.